﻿using System;

namespace ServerSIP
{
    public class cVaxArrayBuff
    {
        private byte[] m_aMainBuff;
        private int m_nTotalSize;

        private int m_nWriteIndex;
        private int m_nGrowSize;

        public cVaxArrayBuff()
        {
            m_aMainBuff = null;
            m_nTotalSize = 0;

            m_nWriteIndex = 0;
            m_nGrowSize = 16000;
        }

        ~cVaxArrayBuff()
        {
            ResetBuff();
        }

        private void AllocBuff()
        {
            if (m_aMainBuff != null)
                return;

            m_aMainBuff = new byte[m_nGrowSize];
            m_nTotalSize = m_nGrowSize;
        }

        private void AdjustBuff(int nDataSize)
        {
            if ((m_nWriteIndex + nDataSize) <= m_nTotalSize)
                return;

            int nTotalSize = m_nTotalSize;

            while (true)
            {
                nTotalSize += m_nGrowSize;

                if ((m_nWriteIndex + nDataSize) <= nTotalSize)
                    break;
            }

            byte[] aDataBuff = new byte[nTotalSize];
            Buffer.BlockCopy(m_aMainBuff, 0, aDataBuff, 0, m_nWriteIndex);

            m_aMainBuff = aDataBuff;
            m_nTotalSize = nTotalSize;
        }

        public void ResetBuff()
        {
            m_nWriteIndex = 0;

            if (m_aMainBuff != null)
            {
                m_aMainBuff = null;
            }

            m_nTotalSize = 0;
        }

        public void SetSizeGrow(int nSize)
        {
            m_nGrowSize = nSize;
        }

        public byte[] GetDataBuff()
        {
            return m_aMainBuff;
        }

        public int GetSizeBuff()
        {
            return m_nWriteIndex;
        }

        public void WriteToBuff(byte[] aDataBuff, int nSizeBuff)
        {
            AllocBuff();

            if (nSizeBuff <= 0)
                return;

            AdjustBuff(nSizeBuff);

            Buffer.BlockCopy(aDataBuff, 0, m_aMainBuff, m_nWriteIndex, nSizeBuff);
            m_nWriteIndex += nSizeBuff;
        }
    }

}
