﻿using System;
using System.Collections;

namespace ServerSIP
{
    class cVaxCallParking
    {
        private static int m_nMusicCallParkingId = -1;

        public static void ResetAll()
        {
            m_nMusicCallParkingId = -1;
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        public static Boolean LoadMusic(String sFileName)
        {
            if (m_nMusicCallParkingId != -1)
            {
                cVaxServerSIP.mVaxSIP.UnLoadWaveID(m_nMusicCallParkingId);
                m_nMusicCallParkingId = -1;
            }

            m_nMusicCallParkingId = cVaxServerSIP.mVaxSIP.LoadWaveFile(sFileName);
            return (m_nMusicCallParkingId != -1);
        }
                
        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        public static void OnIncomingCall(int nSessionId, String sCallerName, String sCallerId, String sDialNo, String sRouteUID)
        {
            StopMusic(nSessionId);
            cVaxServerSIP.mVaxSIP.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, "", sRouteUID);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        public static void OnCallSessionTransferBlind(int nTransfererSessionId, int nTransfererChannelId, String sTransferee, String sTransferTo, String sRouteUID)
        {
            if (!cVaxServerSIP.mVaxSIP.AcceptTransferBlind(nTransfererSessionId, sTransferee, sTransferee, sTransferTo, "", sRouteUID, 30))
                return;

            int nChannelId = cVaxServerCOM.VAX_CALL_CHANNEL_ZERO;
            
            if(nTransfererChannelId == cVaxServerCOM.VAX_CALL_CHANNEL_ZERO)
                nChannelId = cVaxServerCOM.VAX_CALL_CHANNEL_ONE;

            StartMusic(nTransfererSessionId, nChannelId);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////
 
        private static Boolean StartMusic(int nSessionId, int nChannelId)
        {
            int nMusicId = m_nMusicCallParkingId;

            if(nMusicId == -1)
                return false;

            return cVaxServerSIP.mVaxSIP.PlayWaveStartToCallSession(nSessionId, nChannelId, nMusicId, true, 0);
        }

        private static void StopMusic(int nSessionId)
        {
            if (m_nMusicCallParkingId == -1)
                return;

            cVaxServerSIP.mVaxSIP.PlayWaveStopToCallSession(nSessionId, -1, -1);
        }
    }
}
