﻿using System;

namespace ServerSIP
{
    class cVaxCall
    {
        public cVaxCall()
        {
        }
                
        public void OnIncomingCall(int nSessionId, String sCallerName, String sCallerId, String sDialNo, int nFromPeerType, String sFromPeerName, String sToPeerName, ref Boolean bProcessed)
        {
            bProcessed = false;

            if (sDialNo.Length == 0 || sToPeerName.Length == 0)
                return;
                        
            if (!cVaxServerSIP.mVaxSIP.AcceptCallSession(nSessionId, "", "", sDialNo, sToPeerName, ""))
            {
                cVaxServerSIP.mVaxSIP.RejectCallSession(nSessionId, 404, "Not Found");
                return;
            }
                        
            AdjustVoiceType(nSessionId, true, sFromPeerName);
            AdjustVoiceType(nSessionId, false, sToPeerName);

            //cVaxServerSIP.mVaxSIP.DetectDigitDTMF(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO, cVaxServerCOM.VAX_DTMF_TYPE_RFC2833, true, 2000);
            //cVaxServerSIP.mVaxSIP.RecordWaveStartToCallSession(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO, "Record.wav");

            bProcessed = true;
        }

        private void AdjustVoiceType(int nSessionId, Boolean bIsInboundCall, String sPeerName)
        {
            int nChannelId = cVaxServerCOM.VAX_CALL_CHANNEL_ZERO;

            if (bIsInboundCall)
                nChannelId = cVaxServerCOM.VAX_CALL_CHANNEL_ZERO;
            else
                nChannelId = cVaxServerCOM.VAX_CALL_CHANNEL_ONE;

            //////////////////////////////////////////////////////////////////////////////////

            int nVoiceType = cVaxUser.GetVoiceTypeId(sPeerName);

            if (nVoiceType == cVaxServerCOM.VAX_AUDIO_TYPE_ADMIN)     // Admin-Type can only listen to Normal-Type's voice, so adjust voice type from Admin-Type to User-Type. User-Type can speak and listen (both) to Normal-Type.
                nVoiceType = cVaxServerCOM.VAX_AUDIO_TYPE_USER;       // Admin-Type (voice) can be used in call-center for training sessions or stealth listening.
            
            cVaxServerSIP.mVaxSIP.AdjustCallSessionVoiceType(nSessionId, nChannelId, nVoiceType);
        }
     }
}
