﻿using System;
using System.Collections;

namespace ServerSIP
{
    class cVaxLine
    {
        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public static void OnLineRegisterTrying(String sLineName)
        {
            String sStatus = sLineName + " " + cVaxDefine.LINE_REG_TRYING;
            cVaxServerSIP.mVaxSIP.GenStatusLog(sStatus);
        }

        public static void OnLineRegisterFailed(String sLineName, int nStatusCode, String sReasonPhrase)
        {
            String sStatus = sLineName + " Register Failed: " + sReasonPhrase;
            cVaxServerSIP.mVaxSIP.GenStatusLog(sStatus);
        }

        public static void OnLineRegisterSuccess(String sLineName)
        {
            String sStatus = sLineName + " " + cVaxDefine.LINE_REG_SUCCESS;
            cVaxServerSIP.mVaxSIP.GenStatusLog(sStatus);
        }
                               
        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public static Boolean AddLine(String sLineName, int nLineType, String sAuthUser, String sAuthPwd, String sServerAddr, int nServerPort, String sAudioCodecList, Boolean bRegister, String sToPeerName, Boolean bRejected, String sRoomName)
        {
            if (cVaxServerSIP.mVaxSIP.IsInitialized() == false || (sLineName.Length == 0))
                return false;

            RemoveLine(sLineName);

            if (!cVaxServerSIP.mVaxSIP.AddLine(sLineName, nLineType, "", "", sAuthUser, sAuthPwd, "", sServerAddr, nServerPort, sAudioCodecList))
                return false;

            cVaxCallSession.AddLineRoute(sLineName, sToPeerName, bRejected, sRoomName);
                        
            if (bRegister)
                cVaxServerSIP.mVaxSIP.RegisterLine(sLineName, 1800);
            
            cStoreLine.AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName);
            return true;
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public static void RemoveLine(String sLineName)
        {
            if (cVaxServerSIP.mVaxSIP.IsInitialized() == false || (sLineName.Length == 0))
                return;

            cVaxServerSIP.mVaxSIP.RemoveLine(sLineName);
            cVaxCallSession.RemoveLineRoute(sLineName);

            cStoreLine.RemoveLine(sLineName);
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public static void LoadLine()
        {
            if (!cVaxServerSIP.mVaxSIP.IsInitialized())
                return;

            ArrayList objListLines = new ArrayList();
            cStoreLine.GetLineNameAll(ref objListLines);

            if (objListLines.Count == 0)
                return;

            String sAuthUser = "", sAuthPwd = "", sServerAddr = "", sAudioCodecList = "";
            String sToPeerName = "", sRoomName = "";

            Boolean bRejected = false, bRegister = false;
            int nLineType = cVaxServerCOM.VAX_LINE_TYPE_UDP, nServerPort = cVaxServerCOM.SIP_DEFAULT_PORT;

            foreach (String sLineName in objListLines)
            {
                cStoreLine.GetLine(sLineName, ref nLineType, ref sAuthUser, ref sAuthPwd, ref sServerAddr, ref nServerPort, ref sAudioCodecList, ref bRegister, ref sToPeerName, ref bRejected, ref sRoomName);
                AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName);

            }
        }
    }
}
