﻿using System;
using System.Collections;

namespace ServerSIP
{
    class cVaxRoom
    {
        public cVaxRoom()
        {
        }

        ////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////

        public void OnIncomingCall(int nSessionId, String sRoomName, ref Boolean bProcessed)
        {
            bProcessed = false;

            if (sRoomName.Length == 0)
                return;

            if (!cVaxServerSIP.mVaxSIP.AddCallSessionToConferenceRoom(sRoomName, nSessionId))
            {
                cVaxServerSIP.mVaxSIP.RejectCallSession(nSessionId, 404, "Not Found");
                return;
            }

            if (!cVaxServerSIP.mVaxSIP.AcceptCallSession(nSessionId, "", "", "", "", ""))    // Accept incoming call and add to conference room.
            {
                cVaxServerSIP.mVaxSIP.RejectCallSession(nSessionId, 404, "Not Found");
                return;
            }
                        
            bProcessed = true;
        }

        ///////////////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////////////
        
        public static Boolean AddRoom(String sRoomName, String sRoomNo)
        {
            if (cVaxServerSIP.mVaxSIP.IsInitialized() == false || (sRoomName.Length == 0) || (sRoomNo.Length == 0))
                return false;

            RemoveRoom(sRoomName);

            if (!cVaxServerSIP.mVaxSIP.OpenConferenceRoom(sRoomName))
            {
                RemoveRoom(sRoomName);
                return false;
            }

            if (!cVaxServerSIP.mVaxSIP.AddConferenceRoomRouteUID(sRoomName, sRoomNo))
            {
                RemoveRoom(sRoomName);
                return false;
            }
                        
            cStoreRoom.AddRoom(sRoomName, sRoomNo);
            return true;
        }

        public static void RemoveRoom(String sRoomName)
        {
            if (cVaxServerSIP.mVaxSIP.IsInitialized() == false || (sRoomName.Length == 0))
                return;

            cVaxServerSIP.mVaxSIP.CloseConferenceRoom(sRoomName);
            cStoreRoom.RemoveRoom(sRoomName);
        }

        public static void LoadRoom()
        {
            if (!cVaxServerSIP.mVaxSIP.IsInitialized())
                return;

            ArrayList objListRoomName = new ArrayList();
            cStoreRoom.GetRoomNameAll(ref objListRoomName);

            if (objListRoomName.Count == 0) return;

            String sRoomNo = "";

            foreach (String sRoomName in objListRoomName)
            {
                cStoreRoom.GetRoom(sRoomName, ref sRoomNo);
                AddRoom(sRoomName, sRoomNo);
            }
        }
    }
}
