﻿using System;
using System.Collections;

namespace ServerSIP
{
    class cStoreRoom
    {
        const String ROOM_ROOT_PATH = "Rooms\\";

        public static Boolean AddRoom(String sRoomName, String sRoomNo)
        {
            if (sRoomName.Length == 0)
                return false;

            String sKeyPath = ROOM_ROOT_PATH + sRoomName;
            cStoreRegistry objStore = new cStoreRegistry();

            Boolean bResult = objStore.SetTEXT(sKeyPath, "RoomNo", sRoomNo);
            objStore.Close();

            return bResult;
        }

        public static void GetRoom(String sRoomName, ref String sRoomNo)
        {
            String sKeyPath = ROOM_ROOT_PATH + sRoomName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.GetTEXT(sKeyPath, "RoomNo", ref sRoomNo, "");
            objStore.Close();
        }

        public static void RemoveRoom(String sRoomName)
        {
            if (sRoomName.Length == 0)
                return;

            String sKeyPath = ROOM_ROOT_PATH + sRoomName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.DeleteSubKey(sKeyPath);
            objStore.Close();
        }

        public static void GetRoomNameAll(ref ArrayList objList)
        {
            objList.Clear();

            String sKeyPath = ROOM_ROOT_PATH;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.EnumSubKeys(sKeyPath, ref objList);
            objStore.Close();
        }

        public static Boolean IsDataStored()
        {
            cStoreRegistry objStore = new cStoreRegistry();
            Boolean bResult = objStore.IsKeyExist(ROOM_ROOT_PATH);

            objStore.Close();
            return bResult;
        }
    }
}
