﻿using System;
using System.Collections;

namespace ServerSIP
{
    class cStoreUser
    {
        const String USER_ROOT_PATH = "Users\\";
                 
        /////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////

        public static Boolean AddUser(String sUserName, String sPassword, String sAudioCodecList, Boolean bBlocked, int nVoiceTypeId, String sUserPrefix, String sDialPrefix, String sToPeerName)
        {
            if(sUserName.Length == 0)
                return false;

            String sKeyPath = USER_ROOT_PATH + sUserName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.SetTEXT(sKeyPath, "UserName", sUserName);
            objStore.SetTEXT(sKeyPath, "Password", sPassword);

            objStore.SetTEXT(sKeyPath, "AudioCodecList", sAudioCodecList);

            objStore.SetBOOL(sKeyPath, "Blocked", bBlocked);
            objStore.SetINT(sKeyPath, "VoiceTypeId", nVoiceTypeId);

            objStore.Close();

            cStoreUser.AddUserRoute(sUserName, sUserPrefix, sDialPrefix, sToPeerName);
            return true;
        }

        public static void GetUser(String sUserName, ref String sPassword, ref String sAudioCodecList, ref Boolean bBlocked, ref int nVoiceTypeId, ref String sUserPrefix, ref String sDialPrefix, ref String sToPeerName)
        {
            String sKeyPath = USER_ROOT_PATH + sUserName;
            cStoreRegistry objStore = new cStoreRegistry();
                       
            objStore.GetTEXT(sKeyPath, "Password", ref sPassword, "");
            objStore.GetTEXT(sKeyPath, "AudioCodecList", ref sAudioCodecList, "");

            objStore.GetBOOL(sKeyPath, "Blocked", ref bBlocked, false);
            objStore.GetINT(sKeyPath, "VoiceTypeId", ref nVoiceTypeId, cVaxServerCOM.VAX_AUDIO_TYPE_NORMAL);

            objStore.Close();

            cStoreUser.GetUserRoute(sUserName, ref sUserPrefix, ref sDialPrefix, ref sToPeerName);
        }

        public static void RemoveUser(String sUserName)
        {
            if(sUserName.Length == 0)
                return;

            String sKeyPath = USER_ROOT_PATH + sUserName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.DeleteSubKey(sKeyPath);
            objStore.Close();

            RemoveUserRoute(sUserName);
        }

        public static void GetUserAll(ref ArrayList objList)
        {
            String sKeyPath = USER_ROOT_PATH;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.EnumSubKeys(sKeyPath, ref objList);
            objStore.Close();
        }

        /////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////

        private static Boolean AddUserRoute(String sUserName, String sUserPrefix, String sDialPrefix, String sToPeerName)
        {
            if(sUserName.Length == 0)
                return false;

            String sKeyPath = USER_ROOT_PATH + sUserName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.SetTEXT(sKeyPath, "UserPrefix", sUserPrefix);
            objStore.SetTEXT(sKeyPath, "DialPrefix", sDialPrefix);
            objStore.SetTEXT(sKeyPath, "ToPeerName", sToPeerName);

            objStore.Close();

            return true;
        }

        private static void GetUserRoute(String sUserName, ref String sUserPrefix, ref String sDialPrefix, ref String sToPeerName)
        {
            String sKeyPath = USER_ROOT_PATH + sUserName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.GetTEXT(sKeyPath, "UserPrefix", ref sUserPrefix, "");
            objStore.GetTEXT(sKeyPath, "DialPrefix", ref sDialPrefix, "");
            objStore.GetTEXT(sKeyPath, "ToPeerName", ref sToPeerName, "");

            objStore.Close();
        }

        private static void RemoveUserRoute(String sUserName)
        {
            if(sUserName.Length == 0)
                return;

            String sKeyPath = USER_ROOT_PATH + sUserName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.DeleteValue(sKeyPath, "UserPrefix");
            objStore.DeleteValue(sKeyPath, "DialPrefix");
            objStore.DeleteValue(sKeyPath, "ToPeerName");
            
            objStore.Close();
        }

        /////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////

        public static Boolean IsDataStored()
        {
            cStoreRegistry objStore = new cStoreRegistry();
            Boolean bResult = objStore.IsKeyExist(USER_ROOT_PATH);

            objStore.Close();
            return bResult;
        }
    }
}
